---
- name: Which version of semaphore is installed?
  ansible.builtin.command: semaphore version
  register: semaphore_release_installed
  changed_when: false
  failed_when: false

- name: Get latest semaphore release info from Github
  ansible.builtin.uri:
    url: https://api.github.com/repos/semaphoreui/semaphore/releases/latest
    return_content: true
    body_format: json
  register: semaphore_release

- name: Install semaphore (OS dependend)
  ansible.builtin.include_tasks:
    file: "{{ ansible_os_family | lower }}.yml"

- name: Ensure configuration directories exists
  ansible.builtin.file:
    path: "{{ item }}"
    state: directory
    owner: root
    group: root
    mode: "0755"
  loop:
    - "{{ semaphore_root }}"

- name: Configure semaphore startup
  ansible.builtin.template:
    src: semaphore.service
    dest: /etc/systemd/system/semaphore.service
    owner: root
    group: root
    mode: "0644"
  notify:
    - Reload systemd units
    - Restart semaphore

- name: Deploy semaphore configuration
  ansible.builtin.template:
    src: semaphore_config.json
    dest: "{{ semaphore_root }}/semaphore_config.json"
    owner: root
    group: root
    mode: "0644"
  notify: Restart semaphore

- name: Enable semaphore on system startup
  ansible.builtin.service:
    name: semaphore.service
    enabled: true
